# esys.ripley Package

A domain meshed with uniform rectangles or quadrilaterals

## Classes

- `AbstractAssembler`
- `MultiResolutionDomain`
- `RipleyBrick`
- `RipleyDomain`
- `RipleyMultiBrick`
- `RipleyMultiRectangle`
- `RipleyRectangle`

class `esys.ripley.``AbstractAssembler`

  Bases: `Boost.Python.instance`

  `__init__`()

    Raises an exception This class cannot be instantiated from Python

class `esys.ripley.``MultiResolutionDomain`(dim, **kwargs)

  Bases: `object`

  Constructs domains of varying resolutions that are guaranteed to be compatible for cross-domain interpolation. The parameters supplied will be used to construct the coarsest resolution. No coarser domain can be constructed.

  Each domain of finer resolution will have the number of elements in every axis of the coarsest domain multiplied by `2**n`, where `n` is the level of subdivision.

  `__init__`(dim, **kwargs)

    Parameters:

    - dim (`int`) – the spatial dimension of the domain to create
    - kwargs – the arguments normally passed to a constructor of Rectangle or Brick, including as the number of elements `n0=...`, `n1=...`, etc.

  `getLevel`(level)

    Returns a domain with each element subdivided `level` times

    Parameters: | level (`int`) – the number of times to subdivide each element

  `getMaxDepth`()

    Returns the level of the finest domain created so far

class `esys.ripley.``RipleyBrick`

  Bases: `esys.ripley.ripleycpp.RipleyDomain`

  `__init__`()

    Raises an exception This class cannot be instantiated from Python

  `MPIBarrier`((RipleyDomain)arg1) → None :

    Wait until all processes have reached this point

  `addPDEToRHS`((ContinuousDomain)arg1, (Data)rhs, (Data)X, (Data)Y, (Data)y, (Data)y_contact, (Data)y_dirac) → None :

    adds a PDE onto the stiffness matrix mat and a rhs

    Parameters:

    - rhs (`Data`) –
    - X (`Data`) –
    - Y (`Data`) –
    - y (`Data`) –
    - y_contact (`Data`) –
    - y_dirac (`Data`) –

  `addPDEToSystem`((ContinuousDomain)arg1, (Operator)mat, (Data)rhs, (Data)A, (Data)B, (Data)C, (Data)D, (Data)X, (Data)Y, (Data)d, (Data)y, (Data)d_contact, (Data)y_contact, (Data)d_dirac, (Data)y_dirac) → None :

    adds a PDE onto the stiffness matrix mat and a rhs

    Parameters:

    - mat (`OperatorAdapter`) –
    - rhs (`Data`) –
    - A (`Data`) –
    - B (`Data`) –
    - C (`Data`) –
    - D (`Data`) –
    - X (`Data`) –
    - Y (`Data`) –
    - d (`Data`) –
    - d_contact (`Data`) –
    - y_contact (`Data`) –
    - d_dirac (`Data`) –
    - y_dirac (`Data`) –

  `addPDEToTransportProblem`((RipleyDomain)arg1, (TransportProblem)arg2, (Data)tp, (list)source, (AbstractAssembler)data) → None :

    Parameters:

    - tp (`TransportProblemAdapter`) –
    - source (`Data`) –
    - data (`list`) –

  `addToRHS`((RipleyDomain)arg1, (Data)arg2, (list)rhs, (AbstractAssembler)data) → None :

    adds a PDE onto the stiffness matrix mat and a rhs, results depends on domain

    Parameters:

    - rhs (`Data`) –
    - data (`list`) –

  `addToSystem`((RipleyDomain)arg1, (Operator)arg2, (Data)mat, (list)rhs, (AbstractAssembler)data) → None :

    adds a PDE to the system, results depend on domain

    Parameters:

    - mat (`OperatorAdapter`) –
    - rhs (`Data`) –
    - data (`list`) –

  `createAssembler`((RipleyDomain)arg1, (str)typename, (list)options) → AbstractAssembler :

    request from the domain an assembler of the specified type, if supported, using the supplied options (if provided):param typename: :type typename: `string` :param options: :type options: `list`

  `dump`((RipleyDomain)arg1, (str)filename) → None :

    Dumps the mesh to a file with the given name.

  `getDataShape`((RipleyDomain)arg1, (int)functionSpaceCode) → object :

    Returns: | a pair (dps, ns) where dps is the number of data points per sample, and ns is the number of samples
    Return type: | `tuple`

  `getDescription`((RipleyDomain)arg1) → str :

    Returns: | a description for this domain
    Return type: | `string`

  `getDim`((RipleyDomain)arg1) → int :

    Return type: | `int`

  `getGridParameters`((RipleyDomain)arg1) → tuple :
    Returns the tuple (origin, spacing, elements) where the entries are tuples containing
      `origin` the coordinates of the domain’s global origin, `spacing` the element size (node spacing) of the domain, `elements` the global number of elements in all dimensions

    Return type: | `tuple`

  `getMPIRank`((RipleyDomain)arg1) → int :

    Returns: | the rank of this process
    Return type: | `int`

  `getMPISize`((RipleyDomain)arg1) → int :

    Returns: | the number of processes used for this `Domain`
    Return type: | `int`

  `getNormal`((RipleyDomain)arg1) → Data :

    Returns: | boundary normals at the quadrature point on the face elements
    Return type: | `Data`

  `getNumDataPointsGlobal`((RipleyDomain)arg1) → int :

    Returns: | the number of data points summed across all MPI processes
    Return type: | `int`

  `getSize`((RipleyDomain)arg1) → Data :

    Returns: | the element size
    Return type: | `Data`

  `getStatus`((Domain)arg1) → int :

    The status of a domain changes whenever the domain is modified

    Return type: | int

  `getSystemMatrixTypeId`((RipleyDomain)arg1, (object)options) → int :

    Returns: | the identifier of the matrix type to be used for the global stiffness matrix when particular solver options are used.
    Return type: | `int`
    Parameters: | options (`SolverBuddy`) –

  `getTag`((RipleyDomain)arg1, (str)name) → int :

    Returns: | tag id for `name`
    Return type: | `string`

  `getTransportTypeId`((RipleyDomain)arg1, (int)solver, (int)preconditioner, (int)package, (bool)symmetry) → int :

    Returns: | the identifier of the transport problem type to be used when a particular solver, preconditioner, package and symmetric matrix is used.
    Return type: | `int`

    Parameters:

    - solver (`int`) –
    - preconditioner (`int`) –
    - package (`int`) –
    - symmetry (`int`) –

  `getX`((RipleyDomain)arg1) → Data :

    Returns: | locations in the FEM nodes
    Return type: | `Data`

  `isValidTagName`((RipleyDomain)arg1, (str)name) → bool :

    Returns: | True if `name` corresponds to a tag, otherwise False
    Return type: | `bool`

  `newOperator`((RipleyDomain)arg1, (int)row_blocksize, (FunctionSpace)row_functionspace, (int)column_blocksize, (FunctionSpace)column_functionspace, (int)type) → Operator :

    creates a SystemMatrixAdapter stiffness matrix and initializes it with zeros

    Parameters:

    - row_blocksize (`int`) –
    - row_functionspace (`FunctionSpace`) –
    - column_blocksize (`int`) –
    - column_functionspace (`FunctionSpace`) –
    - type (`int`) –

  `newTransportProblem`((RipleyDomain)theta, (int)blocksize, (FunctionSpace)functionspace, (int)type) → TransportProblem :

    creates a TransportProblemAdapter

    Parameters:

    - theta (`float`) –
    - blocksize (`int`) –
    - functionspace (`FunctionSpace`) –
    - type (`int`) –

  `onMasterProcessor`((RipleyDomain)arg1) → bool :

    Returns: | True if this code is executing on the master process
    Return type: | `bool`

  `print_mesh_info`((RipleyDomain)arg1[, (bool)full=False]) → None :

    Prints out a summary about the mesh. :param full: whether to output additional data :type full: `bool`

  `setTagMap`((RipleyDomain)arg1, (str)name, (int)tag) → None :

    Give a tag number a name.

    Parameters:

    - name (`string`) – Name for the tag
    - tag (`int`) – numeric id

    Note: | Tag names must be unique within a domain

  `setX`((ContinuousDomain)arg1, (Data)arg) → None :

    assigns new location to the domain

    Parameters: | arg (`Data`) –

  `showTagNames`((RipleyDomain)arg1) → str :

    Returns: | A space separated list of tag names
    Return type: | `string`

  `supportsContactElements`((Domain)arg1) → bool :

    Does this domain support contact elements.

  `writeBinaryGrid`((RipleyDomain)arg1, (Data)arg2, (str)arg3, (int)arg4, (int)arg5) → None

class `esys.ripley.``RipleyDomain`

  Bases: `esys.escriptcore.escriptcpp.ContinuousDomain`

  `__init__`()

    Raises an exception This class cannot be instantiated from Python

  `MPIBarrier`((RipleyDomain)arg1) → None :

    Wait until all processes have reached this point

  `addPDEToRHS`((ContinuousDomain)arg1, (Data)rhs, (Data)X, (Data)Y, (Data)y, (Data)y_contact, (Data)y_dirac) → None :

    adds a PDE onto the stiffness matrix mat and a rhs

    Parameters:

    - rhs (`Data`) –
    - X (`Data`) –
    - Y (`Data`) –
    - y (`Data`) –
    - y_contact (`Data`) –
    - y_dirac (`Data`) –

  `addPDEToSystem`((ContinuousDomain)arg1, (Operator)mat, (Data)rhs, (Data)A, (Data)B, (Data)C, (Data)D, (Data)X, (Data)Y, (Data)d, (Data)y, (Data)d_contact, (Data)y_contact, (Data)d_dirac, (Data)y_dirac) → None :

    adds a PDE onto the stiffness matrix mat and a rhs

    Parameters:

    - mat (`OperatorAdapter`) –
    - rhs (`Data`) –
    - A (`Data`) –
    - B (`Data`) –
    - C (`Data`) –
    - D (`Data`) –
    - X (`Data`) –
    - Y (`Data`) –
    - d (`Data`) –
    - d_contact (`Data`) –
    - y_contact (`Data`) –
    - d_dirac (`Data`) –
    - y_dirac (`Data`) –

  `addPDEToTransportProblem`((RipleyDomain)arg1, (TransportProblem)arg2, (Data)tp, (list)source, (AbstractAssembler)data) → None :

    Parameters:

    - tp (`TransportProblemAdapter`) –
    - source (`Data`) –
    - data (`list`) –

  `addToRHS`((RipleyDomain)arg1, (Data)arg2, (list)rhs, (AbstractAssembler)data) → None :

    adds a PDE onto the stiffness matrix mat and a rhs, results depends on domain

    Parameters:

    - rhs (`Data`) –
    - data (`list`) –

  `addToSystem`((RipleyDomain)arg1, (Operator)arg2, (Data)mat, (list)rhs, (AbstractAssembler)data) → None :

    adds a PDE to the system, results depend on domain

    Parameters:

    - mat (`OperatorAdapter`) –
    - rhs (`Data`) –
    - data (`list`) –

  `createAssembler`((RipleyDomain)arg1, (str)typename, (list)options) → AbstractAssembler :

    request from the domain an assembler of the specified type, if supported, using the supplied options (if provided):param typename: :type typename: `string` :param options: :type options: `list`

  `dump`((RipleyDomain)arg1, (str)filename) → None :

    Dumps the mesh to a file with the given name.

  `getDataShape`((RipleyDomain)arg1, (int)functionSpaceCode) → object :

    Returns: | a pair (dps, ns) where dps is the number of data points per sample, and ns is the number of samples
    Return type: | `tuple`

  `getDescription`((RipleyDomain)arg1) → str :

    Returns: | a description for this domain
    Return type: | `string`

  `getDim`((RipleyDomain)arg1) → int :

    Return type: | `int`

  `getGridParameters`((RipleyDomain)arg1) → tuple :
    Returns the tuple (origin, spacing, elements) where the entries are tuples containing
      `origin` the coordinates of the domain’s global origin, `spacing` the element size (node spacing) of the domain, `elements` the global number of elements in all dimensions

    Return type: | `tuple`

  `getMPIRank`((RipleyDomain)arg1) → int :

    Returns: | the rank of this process
    Return type: | `int`

  `getMPISize`((RipleyDomain)arg1) → int :

    Returns: | the number of processes used for this `Domain`
    Return type: | `int`

  `getNormal`((RipleyDomain)arg1) → Data :

    Returns: | boundary normals at the quadrature point on the face elements
    Return type: | `Data`

  `getNumDataPointsGlobal`((RipleyDomain)arg1) → int :

    Returns: | the number of data points summed across all MPI processes
    Return type: | `int`

  `getSize`((RipleyDomain)arg1) → Data :

    Returns: | the element size
    Return type: | `Data`

  `getStatus`((Domain)arg1) → int :

    The status of a domain changes whenever the domain is modified

    Return type: | int

  `getSystemMatrixTypeId`((RipleyDomain)arg1, (object)options) → int :

    Returns: | the identifier of the matrix type to be used for the global stiffness matrix when particular solver options are used.
    Return type: | `int`
    Parameters: | options (`SolverBuddy`) –

  `getTag`((RipleyDomain)arg1, (str)name) → int :

    Returns: | tag id for `name`
    Return type: | `string`

  `getTransportTypeId`((RipleyDomain)arg1, (int)solver, (int)preconditioner, (int)package, (bool)symmetry) → int :

    Returns: | the identifier of the transport problem type to be used when a particular solver, preconditioner, package and symmetric matrix is used.
    Return type: | `int`

    Parameters:

    - solver (`int`) –
    - preconditioner (`int`) –
    - package (`int`) –
    - symmetry (`int`) –

  `getX`((RipleyDomain)arg1) → Data :

    Returns: | locations in the FEM nodes
    Return type: | `Data`

  `isValidTagName`((RipleyDomain)arg1, (str)name) → bool :

    Returns: | True if `name` corresponds to a tag, otherwise False
    Return type: | `bool`

  `newOperator`((RipleyDomain)arg1, (int)row_blocksize, (FunctionSpace)row_functionspace, (int)column_blocksize, (FunctionSpace)column_functionspace, (int)type) → Operator :

    creates a SystemMatrixAdapter stiffness matrix and initializes it with zeros

    Parameters:

    - row_blocksize (`int`) –
    - row_functionspace (`FunctionSpace`) –
    - column_blocksize (`int`) –
    - column_functionspace (`FunctionSpace`) –
    - type (`int`) –

  `newTransportProblem`((RipleyDomain)theta, (int)blocksize, (FunctionSpace)functionspace, (int)type) → TransportProblem :

    creates a TransportProblemAdapter

    Parameters:

    - theta (`float`) –
    - blocksize (`int`) –
    - functionspace (`FunctionSpace`) –
    - type (`int`) –

  `onMasterProcessor`((RipleyDomain)arg1) → bool :

    Returns: | True if this code is executing on the master process
    Return type: | `bool`

  `print_mesh_info`((RipleyDomain)arg1[, (bool)full=False]) → None :

    Prints out a summary about the mesh. :param full: whether to output additional data :type full: `bool`

  `setTagMap`((RipleyDomain)arg1, (str)name, (int)tag) → None :

    Give a tag number a name.

    Parameters:

    - name (`string`) – Name for the tag
    - tag (`int`) – numeric id

    Note: | Tag names must be unique within a domain

  `setX`((ContinuousDomain)arg1, (Data)arg) → None :

    assigns new location to the domain

    Parameters: | arg (`Data`) –

  `showTagNames`((RipleyDomain)arg1) → str :

    Returns: | A space separated list of tag names
    Return type: | `string`

  `supportsContactElements`((Domain)arg1) → bool :

    Does this domain support contact elements.

  `writeBinaryGrid`((RipleyDomain)arg1, (Data)arg2, (str)arg3, (int)arg4, (int)arg5) → None

class `esys.ripley.``RipleyMultiBrick`

  Bases: `esys.ripley.ripleycpp.RipleyDomain`

  `__init__`()

    Raises an exception This class cannot be instantiated from Python

  `MPIBarrier`((RipleyDomain)arg1) → None :

    Wait until all processes have reached this point

  `addPDEToRHS`((ContinuousDomain)arg1, (Data)rhs, (Data)X, (Data)Y, (Data)y, (Data)y_contact, (Data)y_dirac) → None :

    adds a PDE onto the stiffness matrix mat and a rhs

    Parameters:

    - rhs (`Data`) –
    - X (`Data`) –
    - Y (`Data`) –
    - y (`Data`) –
    - y_contact (`Data`) –
    - y_dirac (`Data`) –

  `addPDEToSystem`((ContinuousDomain)arg1, (Operator)mat, (Data)rhs, (Data)A, (Data)B, (Data)C, (Data)D, (Data)X, (Data)Y, (Data)d, (Data)y, (Data)d_contact, (Data)y_contact, (Data)d_dirac, (Data)y_dirac) → None :

    adds a PDE onto the stiffness matrix mat and a rhs

    Parameters:

    - mat (`OperatorAdapter`) –
    - rhs (`Data`) –
    - A (`Data`) –
    - B (`Data`) –
    - C (`Data`) –
    - D (`Data`) –
    - X (`Data`) –
    - Y (`Data`) –
    - d (`Data`) –
    - d_contact (`Data`) –
    - y_contact (`Data`) –
    - d_dirac (`Data`) –
    - y_dirac (`Data`) –

  `addPDEToTransportProblem`((RipleyDomain)arg1, (TransportProblem)arg2, (Data)tp, (list)source, (AbstractAssembler)data) → None :

    Parameters:

    - tp (`TransportProblemAdapter`) –
    - source (`Data`) –
    - data (`list`) –

  `addToRHS`((RipleyDomain)arg1, (Data)arg2, (list)rhs, (AbstractAssembler)data) → None :

    adds a PDE onto the stiffness matrix mat and a rhs, results depends on domain

    Parameters:

    - rhs (`Data`) –
    - data (`list`) –

  `addToSystem`((RipleyDomain)arg1, (Operator)arg2, (Data)mat, (list)rhs, (AbstractAssembler)data) → None :

    adds a PDE to the system, results depend on domain

    Parameters:

    - mat (`OperatorAdapter`) –
    - rhs (`Data`) –
    - data (`list`) –

  `createAssembler`((RipleyDomain)arg1, (str)typename, (list)options) → AbstractAssembler :

    request from the domain an assembler of the specified type, if supported, using the supplied options (if provided):param typename: :type typename: `string` :param options: :type options: `list`

  `dump`((RipleyDomain)arg1, (str)filename) → None :

    Dumps the mesh to a file with the given name.

  `getDataShape`((RipleyDomain)arg1, (int)functionSpaceCode) → object :

    Returns: | a pair (dps, ns) where dps is the number of data points per sample, and ns is the number of samples
    Return type: | `tuple`

  `getDescription`((RipleyDomain)arg1) → str :

    Returns: | a description for this domain
    Return type: | `string`

  `getDim`((RipleyDomain)arg1) → int :

    Return type: | `int`

  `getGridParameters`((RipleyDomain)arg1) → tuple :
    Returns the tuple (origin, spacing, elements) where the entries are tuples containing
      `origin` the coordinates of the domain’s global origin, `spacing` the element size (node spacing) of the domain, `elements` the global number of elements in all dimensions

    Return type: | `tuple`

  `getMPIRank`((RipleyDomain)arg1) → int :

    Returns: | the rank of this process
    Return type: | `int`

  `getMPISize`((RipleyDomain)arg1) → int :

    Returns: | the number of processes used for this `Domain`
    Return type: | `int`

  `getNormal`((RipleyDomain)arg1) → Data :

    Returns: | boundary normals at the quadrature point on the face elements
    Return type: | `Data`

  `getNumDataPointsGlobal`((RipleyDomain)arg1) → int :

    Returns: | the number of data points summed across all MPI processes
    Return type: | `int`

  `getSize`((RipleyDomain)arg1) → Data :

    Returns: | the element size
    Return type: | `Data`

  `getStatus`((Domain)arg1) → int :

    The status of a domain changes whenever the domain is modified

    Return type: | int

  `getSystemMatrixTypeId`((RipleyDomain)arg1, (object)options) → int :

    Returns: | the identifier of the matrix type to be used for the global stiffness matrix when particular solver options are used.
    Return type: | `int`
    Parameters: | options (`SolverBuddy`) –

  `getTag`((RipleyDomain)arg1, (str)name) → int :

    Returns: | tag id for `name`
    Return type: | `string`

  `getTransportTypeId`((RipleyDomain)arg1, (int)solver, (int)preconditioner, (int)package, (bool)symmetry) → int :

    Returns: | the identifier of the transport problem type to be used when a particular solver, preconditioner, package and symmetric matrix is used.
    Return type: | `int`

    Parameters:

    - solver (`int`) –
    - preconditioner (`int`) –
    - package (`int`) –
    - symmetry (`int`) –

  `getX`((RipleyDomain)arg1) → Data :

    Returns: | locations in the FEM nodes
    Return type: | `Data`

  `isValidTagName`((RipleyDomain)arg1, (str)name) → bool :

    Returns: | True if `name` corresponds to a tag, otherwise False
    Return type: | `bool`

  `newOperator`((RipleyDomain)arg1, (int)row_blocksize, (FunctionSpace)row_functionspace, (int)column_blocksize, (FunctionSpace)column_functionspace, (int)type) → Operator :

    creates a SystemMatrixAdapter stiffness matrix and initializes it with zeros

    Parameters:

    - row_blocksize (`int`) –
    - row_functionspace (`FunctionSpace`) –
    - column_blocksize (`int`) –
    - column_functionspace (`FunctionSpace`) –
    - type (`int`) –

  `newTransportProblem`((RipleyDomain)theta, (int)blocksize, (FunctionSpace)functionspace, (int)type) → TransportProblem :

    creates a TransportProblemAdapter

    Parameters:

    - theta (`float`) –
    - blocksize (`int`) –
    - functionspace (`FunctionSpace`) –
    - type (`int`) –

  `onMasterProcessor`((RipleyDomain)arg1) → bool :

    Returns: | True if this code is executing on the master process
    Return type: | `bool`

  `print_mesh_info`((RipleyDomain)arg1[, (bool)full=False]) → None :

    Prints out a summary about the mesh. :param full: whether to output additional data :type full: `bool`

  `setTagMap`((RipleyDomain)arg1, (str)name, (int)tag) → None :

    Give a tag number a name.

    Parameters:

    - name (`string`) – Name for the tag
    - tag (`int`) – numeric id

    Note: | Tag names must be unique within a domain

  `setX`((ContinuousDomain)arg1, (Data)arg) → None :

    assigns new location to the domain

    Parameters: | arg (`Data`) –

  `showTagNames`((RipleyDomain)arg1) → str :

    Returns: | A space separated list of tag names
    Return type: | `string`

  `supportsContactElements`((Domain)arg1) → bool :

    Does this domain support contact elements.

  `writeBinaryGrid`((RipleyDomain)arg1, (Data)arg2, (str)arg3, (int)arg4, (int)arg5) → None

class `esys.ripley.``RipleyMultiRectangle`

  Bases: `esys.ripley.ripleycpp.RipleyDomain`

  `__init__`()

    Raises an exception This class cannot be instantiated from Python

  `MPIBarrier`((RipleyDomain)arg1) → None :

    Wait until all processes have reached this point

  `addPDEToRHS`((ContinuousDomain)arg1, (Data)rhs, (Data)X, (Data)Y, (Data)y, (Data)y_contact, (Data)y_dirac) → None :

    adds a PDE onto the stiffness matrix mat and a rhs

    Parameters:

    - rhs (`Data`) –
    - X (`Data`) –
    - Y (`Data`) –
    - y (`Data`) –
    - y_contact (`Data`) –
    - y_dirac (`Data`) –

  `addPDEToSystem`((ContinuousDomain)arg1, (Operator)mat, (Data)rhs, (Data)A, (Data)B, (Data)C, (Data)D, (Data)X, (Data)Y, (Data)d, (Data)y, (Data)d_contact, (Data)y_contact, (Data)d_dirac, (Data)y_dirac) → None :

    adds a PDE onto the stiffness matrix mat and a rhs

    Parameters:

    - mat (`OperatorAdapter`) –
    - rhs (`Data`) –
    - A (`Data`) –
    - B (`Data`) –
    - C (`Data`) –
    - D (`Data`) –
    - X (`Data`) –
    - Y (`Data`) –
    - d (`Data`) –
    - d_contact (`Data`) –
    - y_contact (`Data`) –
    - d_dirac (`Data`) –
    - y_dirac (`Data`) –

  `addPDEToTransportProblem`((RipleyDomain)arg1, (TransportProblem)arg2, (Data)tp, (list)source, (AbstractAssembler)data) → None :

    Parameters:

    - tp (`TransportProblemAdapter`) –
    - source (`Data`) –
    - data (`list`) –

  `addToRHS`((RipleyDomain)arg1, (Data)arg2, (list)rhs, (AbstractAssembler)data) → None :

    adds a PDE onto the stiffness matrix mat and a rhs, results depends on domain

    Parameters:

    - rhs (`Data`) –
    - data (`list`) –

  `addToSystem`((RipleyDomain)arg1, (Operator)arg2, (Data)mat, (list)rhs, (AbstractAssembler)data) → None :

    adds a PDE to the system, results depend on domain

    Parameters:

    - mat (`OperatorAdapter`) –
    - rhs (`Data`) –
    - data (`list`) –

  `createAssembler`((RipleyDomain)arg1, (str)typename, (list)options) → AbstractAssembler :

    request from the domain an assembler of the specified type, if supported, using the supplied options (if provided):param typename: :type typename: `string` :param options: :type options: `list`

  `dump`((RipleyDomain)arg1, (str)filename) → None :

    Dumps the mesh to a file with the given name.

  `getDataShape`((RipleyDomain)arg1, (int)functionSpaceCode) → object :

    Returns: | a pair (dps, ns) where dps is the number of data points per sample, and ns is the number of samples
    Return type: | `tuple`

  `getDescription`((RipleyDomain)arg1) → str :

    Returns: | a description for this domain
    Return type: | `string`

  `getDim`((RipleyDomain)arg1) → int :

    Return type: | `int`

  `getGridParameters`((RipleyDomain)arg1) → tuple :
    Returns the tuple (origin, spacing, elements) where the entries are tuples containing
      `origin` the coordinates of the domain’s global origin, `spacing` the element size (node spacing) of the domain, `elements` the global number of elements in all dimensions

    Return type: | `tuple`

  `getMPIRank`((RipleyDomain)arg1) → int :

    Returns: | the rank of this process
    Return type: | `int`

  `getMPISize`((RipleyDomain)arg1) → int :

    Returns: | the number of processes used for this `Domain`
    Return type: | `int`

  `getNormal`((RipleyDomain)arg1) → Data :

    Returns: | boundary normals at the quadrature point on the face elements
    Return type: | `Data`

  `getNumDataPointsGlobal`((RipleyDomain)arg1) → int :

    Returns: | the number of data points summed across all MPI processes
    Return type: | `int`

  `getSize`((RipleyDomain)arg1) → Data :

    Returns: | the element size
    Return type: | `Data`

  `getStatus`((Domain)arg1) → int :

    The status of a domain changes whenever the domain is modified

    Return type: | int

  `getSystemMatrixTypeId`((RipleyDomain)arg1, (object)options) → int :

    Returns: | the identifier of the matrix type to be used for the global stiffness matrix when particular solver options are used.
    Return type: | `int`
    Parameters: | options (`SolverBuddy`) –

  `getTag`((RipleyDomain)arg1, (str)name) → int :

    Returns: | tag id for `name`
    Return type: | `string`

  `getTransportTypeId`((RipleyDomain)arg1, (int)solver, (int)preconditioner, (int)package, (bool)symmetry) → int :

    Returns: | the identifier of the transport problem type to be used when a particular solver, preconditioner, package and symmetric matrix is used.
    Return type: | `int`

    Parameters:

    - solver (`int`) –
    - preconditioner (`int`) –
    - package (`int`) –
    - symmetry (`int`) –

  `getX`((RipleyDomain)arg1) → Data :

    Returns: | locations in the FEM nodes
    Return type: | `Data`

  `isValidTagName`((RipleyDomain)arg1, (str)name) → bool :

    Returns: | True if `name` corresponds to a tag, otherwise False
    Return type: | `bool`

  `newOperator`((RipleyDomain)arg1, (int)row_blocksize, (FunctionSpace)row_functionspace, (int)column_blocksize, (FunctionSpace)column_functionspace, (int)type) → Operator :

    creates a SystemMatrixAdapter stiffness matrix and initializes it with zeros

    Parameters:

    - row_blocksize (`int`) –
    - row_functionspace (`FunctionSpace`) –
    - column_blocksize (`int`) –
    - column_functionspace (`FunctionSpace`) –
    - type (`int`) –

  `newTransportProblem`((RipleyDomain)theta, (int)blocksize, (FunctionSpace)functionspace, (int)type) → TransportProblem :

    creates a TransportProblemAdapter

    Parameters:

    - theta (`float`) –
    - blocksize (`int`) –
    - functionspace (`FunctionSpace`) –
    - type (`int`) –

  `onMasterProcessor`((RipleyDomain)arg1) → bool :

    Returns: | True if this code is executing on the master process
    Return type: | `bool`

  `print_mesh_info`((RipleyDomain)arg1[, (bool)full=False]) → None :

    Prints out a summary about the mesh. :param full: whether to output additional data :type full: `bool`

  `setTagMap`((RipleyDomain)arg1, (str)name, (int)tag) → None :

    Give a tag number a name.

    Parameters:

    - name (`string`) – Name for the tag
    - tag (`int`) – numeric id

    Note: | Tag names must be unique within a domain

  `setX`((ContinuousDomain)arg1, (Data)arg) → None :

    assigns new location to the domain

    Parameters: | arg (`Data`) –

  `showTagNames`((RipleyDomain)arg1) → str :

    Returns: | A space separated list of tag names
    Return type: | `string`

  `supportsContactElements`((Domain)arg1) → bool :

    Does this domain support contact elements.

  `writeBinaryGrid`((RipleyDomain)arg1, (Data)arg2, (str)arg3, (int)arg4, (int)arg5) → None

class `esys.ripley.``RipleyRectangle`

  Bases: `esys.ripley.ripleycpp.RipleyDomain`

  `__init__`()

    Raises an exception This class cannot be instantiated from Python

  `MPIBarrier`((RipleyDomain)arg1) → None :

    Wait until all processes have reached this point

  `addPDEToRHS`((ContinuousDomain)arg1, (Data)rhs, (Data)X, (Data)Y, (Data)y, (Data)y_contact, (Data)y_dirac) → None :

    adds a PDE onto the stiffness matrix mat and a rhs

    Parameters:

    - rhs (`Data`) –
    - X (`Data`) –
    - Y (`Data`) –
    - y (`Data`) –
    - y_contact (`Data`) –
    - y_dirac (`Data`) –

  `addPDEToSystem`((ContinuousDomain)arg1, (Operator)mat, (Data)rhs, (Data)A, (Data)B, (Data)C, (Data)D, (Data)X, (Data)Y, (Data)d, (Data)y, (Data)d_contact, (Data)y_contact, (Data)d_dirac, (Data)y_dirac) → None :

    adds a PDE onto the stiffness matrix mat and a rhs

    Parameters:

    - mat (`OperatorAdapter`) –
    - rhs (`Data`) –
    - A (`Data`) –
    - B (`Data`) –
    - C (`Data`) –
    - D (`Data`) –
    - X (`Data`) –
    - Y (`Data`) –
    - d (`Data`) –
    - d_contact (`Data`) –
    - y_contact (`Data`) –
    - d_dirac (`Data`) –
    - y_dirac (`Data`) –

  `addPDEToTransportProblem`((RipleyDomain)arg1, (TransportProblem)arg2, (Data)tp, (list)source, (AbstractAssembler)data) → None :

    Parameters:

    - tp (`TransportProblemAdapter`) –
    - source (`Data`) –
    - data (`list`) –

  `addToRHS`((RipleyDomain)arg1, (Data)arg2, (list)rhs, (AbstractAssembler)data) → None :

    adds a PDE onto the stiffness matrix mat and a rhs, results depends on domain

    Parameters:

    - rhs (`Data`) –
    - data (`list`) –

  `addToSystem`((RipleyDomain)arg1, (Operator)arg2, (Data)mat, (list)rhs, (AbstractAssembler)data) → None :

    adds a PDE to the system, results depend on domain

    Parameters:

    - mat (`OperatorAdapter`) –
    - rhs (`Data`) –
    - data (`list`) –

  `createAssembler`((RipleyDomain)arg1, (str)typename, (list)options) → AbstractAssembler :

    request from the domain an assembler of the specified type, if supported, using the supplied options (if provided):param typename: :type typename: `string` :param options: :type options: `list`

  `dump`((RipleyDomain)arg1, (str)filename) → None :

    Dumps the mesh to a file with the given name.

  `getDataShape`((RipleyDomain)arg1, (int)functionSpaceCode) → object :

    Returns: | a pair (dps, ns) where dps is the number of data points per sample, and ns is the number of samples
    Return type: | `tuple`

  `getDescription`((RipleyDomain)arg1) → str :

    Returns: | a description for this domain
    Return type: | `string`

  `getDim`((RipleyDomain)arg1) → int :

    Return type: | `int`

  `getGridParameters`((RipleyDomain)arg1) → tuple :
    Returns the tuple (origin, spacing, elements) where the entries are tuples containing
      `origin` the coordinates of the domain’s global origin, `spacing` the element size (node spacing) of the domain, `elements` the global number of elements in all dimensions

    Return type: | `tuple`

  `getMPIRank`((RipleyDomain)arg1) → int :

    Returns: | the rank of this process
    Return type: | `int`

  `getMPISize`((RipleyDomain)arg1) → int :

    Returns: | the number of processes used for this `Domain`
    Return type: | `int`

  `getNormal`((RipleyDomain)arg1) → Data :

    Returns: | boundary normals at the quadrature point on the face elements
    Return type: | `Data`

  `getNumDataPointsGlobal`((RipleyDomain)arg1) → int :

    Returns: | the number of data points summed across all MPI processes
    Return type: | `int`

  `getSize`((RipleyDomain)arg1) → Data :

    Returns: | the element size
    Return type: | `Data`

  `getStatus`((Domain)arg1) → int :

    The status of a domain changes whenever the domain is modified

    Return type: | int

  `getSystemMatrixTypeId`((RipleyDomain)arg1, (object)options) → int :

    Returns: | the identifier of the matrix type to be used for the global stiffness matrix when particular solver options are used.
    Return type: | `int`
    Parameters: | options (`SolverBuddy`) –

  `getTag`((RipleyDomain)arg1, (str)name) → int :

    Returns: | tag id for `name`
    Return type: | `string`

  `getTransportTypeId`((RipleyDomain)arg1, (int)solver, (int)preconditioner, (int)package, (bool)symmetry) → int :

    Returns: | the identifier of the transport problem type to be used when a particular solver, preconditioner, package and symmetric matrix is used.
    Return type: | `int`

    Parameters:

    - solver (`int`) –
    - preconditioner (`int`) –
    - package (`int`) –
    - symmetry (`int`) –

  `getX`((RipleyDomain)arg1) → Data :

    Returns: | locations in the FEM nodes
    Return type: | `Data`

  `isValidTagName`((RipleyDomain)arg1, (str)name) → bool :

    Returns: | True if `name` corresponds to a tag, otherwise False
    Return type: | `bool`

  `newOperator`((RipleyDomain)arg1, (int)row_blocksize, (FunctionSpace)row_functionspace, (int)column_blocksize, (FunctionSpace)column_functionspace, (int)type) → Operator :

    creates a SystemMatrixAdapter stiffness matrix and initializes it with zeros

    Parameters:

    - row_blocksize (`int`) –
    - row_functionspace (`FunctionSpace`) –
    - column_blocksize (`int`) –
    - column_functionspace (`FunctionSpace`) –
    - type (`int`) –

  `newTransportProblem`((RipleyDomain)theta, (int)blocksize, (FunctionSpace)functionspace, (int)type) → TransportProblem :

    creates a TransportProblemAdapter

    Parameters:

    - theta (`float`) –
    - blocksize (`int`) –
    - functionspace (`FunctionSpace`) –
    - type (`int`) –

  `onMasterProcessor`((RipleyDomain)arg1) → bool :

    Returns: | True if this code is executing on the master process
    Return type: | `bool`

  `print_mesh_info`((RipleyDomain)arg1[, (bool)full=False]) → None :

    Prints out a summary about the mesh. :param full: whether to output additional data :type full: `bool`

  `setTagMap`((RipleyDomain)arg1, (str)name, (int)tag) → None :

    Give a tag number a name.

    Parameters:

    - name (`string`) – Name for the tag
    - tag (`int`) – numeric id

    Note: | Tag names must be unique within a domain

  `setX`((ContinuousDomain)arg1, (Data)arg) → None :

    assigns new location to the domain

    Parameters: | arg (`Data`) –

  `showTagNames`((RipleyDomain)arg1) → str :

    Returns: | A space separated list of tag names
    Return type: | `string`

  `supportsContactElements`((Domain)arg1) → bool :

    Does this domain support contact elements.

  `writeBinaryGrid`((RipleyDomain)arg1, (Data)arg2, (str)arg3, (int)arg4, (int)arg5) → None

## Functions

`esys.ripley.``Brick`((float)n0, (float)n1, (float)n2[, (object)l0=1.0[, (object)l1=1.0[, (object)l2=1.0[, (int)d0=-1[, (int)d1=-1[, (int)d2=-1[, (object)diracPoints=[][, (object)diracTags=[][, (SubWorld)escriptworld=None]]]]]]]]]) → Domain :

  Creates a hexagonal mesh with n0 x n1 x n2 elements over the brick [0,l0] x [0,l1] x [0,l2].

  Parameters:

  - n0 (`int`) – number of elements in direction 0
  - n1 (`int`) – number of elements in direction 1
  - n2 (`int`) – number of elements in direction 2
  - l0 (`float` or `tuple`) – length of side 0 or coordinate range of side 0
  - l1 (`float` or `tuple`) – length of side 1 or coordinate range of side 1
  - l2 (`float` or `tuple`) – length of side 2 or coordinate range of side 2
  - d0 (`int`) – number of subdivisions in direction 0
  - d1 (`int`) – number of subdivisions in direction 1
  - d2 (`int`) – number of subdivisions in direction 2

`esys.ripley.``MultiBrick`((float)n0, (float)n1, (float)n2[, (object)l0=1.0[, (object)l1=1.0[, (object)l2=1.0[, (int)d0=-1[, (int)d1=-1[, (int)d2=-1[, (object)diracPoints=[][, (object)diracTags=[][, (SubWorld)escriptworld=None[, (int)multiplier=1]]]]]]]]]]) → Domain :

  Creates a hexagonal mesh with n0 x n1 x n2 parent elements over the brick [0,l0] x [0,l1] x [0,l2], each parent element is divided `multiplier` times.

  Parameters:

  - n0 (`int`) – number of elements in direction 0
  - n1 (`int`) – number of elements in direction 1
  - n2 (`int`) – number of elements in direction 2
  - l0 (`float` or `tuple`) – length of side 0 or coordinate range of side 0
  - l1 (`float` or `tuple`) – length of side 1 or coordinate range of side 1
  - l2 (`float` or `tuple`) – length of side 2 or coordinate range of side 2
  - d0 (`int`) – number of subdivisions in direction 0
  - d1 (`int`) – number of subdivisions in direction 1
  - d2 (`int`:param multiplier: size of overlap) – number of subdivisions in direction 2

`esys.ripley.``MultiRectangle`((float)n0, (float)n1[, (object)l0=1.0[, (object)l1=1.0[, (int)d0=-1[, (int)d1=-1[, (object)diracPoints=[][, (object)diracTags=[][, (SubWorld)escriptworld=None[, (int)multiplier=1]]]]]]]]) → Domain :

  Creates a rectangular mesh with n0 x n1 parent elements over the rectangle [0,l0] x [0,l1], each parent element is divided `multiplier` times.

  Parameters:

  - n0 (`int`) – number of elements in direction 0
  - n1 (`int`) – number of elements in direction 1
  - l0 (`float` or `tuple`) – length of side 0 or coordinate range of side 0
  - l1 (`float` or `tuple`) – length of side 1 or coordinate range of side 1
  - d0 (`int`) – number of subdivisions in direction 0
  - d1 (`int`) – number of subdivisions in direction 1
  - multiplier (`unsigned int`) – size of overlap

`esys.ripley.``Rectangle`((float)n0, (float)n1[, (object)l0=1.0[, (object)l1=1.0[, (int)d0=-1[, (int)d1=-1[, (object)diracPoints=[][, (object)diracTags=[][, (SubWorld)escriptworld=None]]]]]]]) → Domain :

  Creates a rectangular mesh with n0 x n1 elements over the rectangle [0,l0] x [0,l1].

  Parameters:

  - n0 (`int`) – number of elements in direction 0
  - n1 (`int`) – number of elements in direction 1
  - l0 (`float` or `tuple`) – length of side 0 or coordinate range of side 0
  - l1 (`float` or `tuple`) – length of side 1 or coordinate range of side 1
  - d0 (`int`) – number of subdivisions in direction 0
  - d1 (`int`) – number of subdivisions in direction 1

`esys.ripley.``readBinaryGrid`((str)filename, (FunctionSpace)functionspace, (object)shape, (float)fill=0.0, (int)byteOrder, (int)dataType, (object)first, (object)numValues, (object)multiplier, (object)reverse) → Data :

  Reads a binary Grid

`esys.ripley.``setDecompositionPolicy`((int)value) → None :

  Sets the automatic domain decomposition policy for new domains.

  Parameters: | value (`int`) – policy

## Others

- BYTEORDER_BIG_ENDIAN
- BYTEORDER_LITTLE_ENDIAN
- BYTEORDER_NATIVE
- DATATYPE_FLOAT32
- DATATYPE_FLOAT64
- DATATYPE_INT32
- DECOMP_ADD_ELEMENTS
- DECOMP_EXPAND
- DECOMP_STRICT

## Packages